package gssim.gssimstudio.editor.gssim.topology
{
	/**
	 * Factory for creating objects for network topology
	 */
	public class GenderObjectFactory
	{
		private static var routerCount : Number = 0;
		private static var resourceCount : Number = 0;
		private static var userCount : Number = 0;
		private static var clusterCount : Number = 0;
		
		public static function resetFactory() : void {
			routerCount = 0;
			resourceCount = 0;
			userCount = 0;
			clusterCount = 0;
		}
		
		public static function createRouter(posX : int, posY : int, width : int, height: int) : RouterObject
		{
			var object : RouterObject = new RouterObject("null");
				object.width = width;
				object.height = height;
				object.x = posX;
				object.y = posY;
				routerCount += 1;
				object.nodeName = "Router " + routerCount;
			return object;
		}

		public static function createResource(posX : int, posY : int, width : int, height: int) : ResourceObject
		{
			var object : ResourceObject = new ResourceObject("null");
				object.width = width;
				object.height = height;
				object.x = posX;
				object.y = posY;
				resourceCount += 1;
				object.nodeName = "Resource " + resourceCount;
			return object;
		}
		
		public static function createUser(posX : int, posY : int, width : int, height: int) : UserObject
		{
			var object : UserObject = new UserObject("null");
				object.width = width;
				object.height = height;
				object.x = posX;
				object.y = posY;
				userCount += 1;
				object.nodeName = "User " + userCount;
			return object;
		}
		
		public static function createCluster(posX : int, posY : int, width : int, height: int) : ResourceObject
		{
			var object : ResourceObject = new ResourceObject("null", true);
			object.width = width;
			object.height = height;
			object.x = posX;
			object.y = posY;
			clusterCount += 1;
			object.nodeName = "Cluster " + clusterCount;
			return object;
		}
	}
}
